package xena;

import java.util.ArrayList;

import xena.XenaPacket.packetHeaderTypes;

// ======================================= TYPES ===========================================
public class packetHeader {
	public packetHeaderTypes headerType;
	public long srcMac;
	public long destMac;
	public int type;
	public int priority;
	public int vid;
	public int pcp;
	public int cfi;
	public int Version;
	public int DifServCP;
	public int ECN;
	public int TLEngth;
	public int Id;
	public int Flags;
	public int FOffset;
	public int TLive;
	public int Protocol;	
	public int HChecksum;
	public int Src_IP;
	public int Dst_IP;
	public int Label;
	public int Exp;
	public int Bottom;
	public int TimeToLive;
	ArrayList<headerModifier> modifiers;
	
	public ArrayList<headerModifier> getModifiers() {
		return modifiers;
	}

	public void setModifiers(ArrayList<headerModifier> modifiers) {
		this.modifiers = modifiers;
	}

	public packetHeader(packetHeaderTypes _headerType, byte _srcMac, byte _destMac, byte _type,byte _priority, byte _vid, byte _pcp, byte _cfi, byte _DifServCP, byte _Exp, byte _Label, byte _Bottom, byte _TimeToLive) {
		headerType = _headerType;
		srcMac = _srcMac;
		destMac = _destMac;
		type = _type;
		priority= _priority;
		vid = _vid;
		pcp = _pcp;
		cfi = _cfi;
		DifServCP = _DifServCP;
		Exp = _Exp;
		Label =_Label;
		Bottom= _Bottom;
		TimeToLive=_TimeToLive;
	
		modifiers = new ArrayList<headerModifier>();
	}
	
	public packetHeader() {
		this(packetHeaderTypes.ETH, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0, (byte)0x0);
	}
	
	public packetHeader(packetHeaderTypes _type) {
		headerType = _type;
		this.modifiers = new ArrayList<headerModifier>();
		
		switch (headerType) {
		case ETH:			
			srcMac = 0x110000000000L;
			destMac = 0x101000000000L;
			type = (byte) 0x8100;
			break;
		case IP:
			DifServCP = 0x8;
			type = 0x800;
			break;
		case CVLAN:
			vid = (byte)0x1234;
			pcp = 0x02;
			type = (byte)0x8100;
			priority = 1;
			break;
		case SVLAN:
			vid =(byte) 0x1234;
			pcp = 0x02;
			type = (byte)0x8100;
			priority = 1;
			break;
		case MPLS:			
			Exp = 1;			
			type = 0x8847;
			break;
		default:
			return;
		}
	}
	public packetHeader(packetHeaderTypes _type, int _nextHeaderType){
		headerType = _type;
		this.modifiers = new ArrayList<headerModifier>();
		
		switch (headerType) {
		case ETH:			
			srcMac = 0x110000000000L;
			destMac = 0x101000000000L;
			type = (byte) _nextHeaderType;
			break;
		case IP:
			DifServCP = 0x8;
			type = _nextHeaderType;
			break;
		case CVLAN:
			vid = (byte)0x1234;
			pcp = 0x02;
			type = (byte)_nextHeaderType;
			priority = 1;
			break;
		case SVLAN:
			vid =(byte) 0x1234;
			pcp = 0x02;
			type = (byte)_nextHeaderType;
			priority = 1;
			break;
		case MPLS:			
			Exp = 1;			
			type = _nextHeaderType;
			break;
		default:
			return;
	}
}
}