package xena;

import java.io.Serializable;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.apache.commons.io.*;

@SuppressWarnings("serial")
public class pcapFileHeader implements Serializable {
    int magic_number =  0xa1b2c3d4;   /* magic number */
    short   version_major = (short)2;  /* major version number */
    short   version_minor = (short)4;  /* minor version number */
    int thiszone = 0;       /* GMT to local correction */
    int sigfigs = 0;        /* accuracy of timestamps */
    int snaplen = 65535;        /* max length of captured packets, in octets */
    int network = 1;        /* data link type */

    static int size = 24;
    
    public static int getSize() {
    	return size;
    }
    
    public byte[] toByteArray() {
    	ByteBuffer buf = ByteBuffer.allocate(size);
    	buf.putInt(0, magic_number);
    	buf.putShort(4, version_major);
    	buf.putShort(6, version_minor);
    	buf.putInt(8, thiszone);
    	buf.putInt(12, sigfigs);
    	buf.putInt(16, snaplen);
    	buf.putInt(20, network);    	
    	
    	return buf.array();
    }

    public static pcapFileHeader setFromByteArray(byte[] byteArray) {
    	pcapFileHeader theHeader = new pcapFileHeader();

    	if (byteArray != null) {
	    	if (byteArray.length == size) {
		    	theHeader.magic_number = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 0, 4)), 16);
		    	theHeader.version_major = (short)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 4, 6)), 16);
		    	theHeader.version_minor = (short)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 6, 8)), 16);
		    	theHeader.thiszone = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 8, 12)), 16);
		    	theHeader.sigfigs = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 12, 16)), 16);
		    	theHeader.snaplen = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 16, 20)), 16);
		    	theHeader.network = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 20, 24)), 16);
		    	if (theHeader.magic_number == 0xD4C3B2A1) {
			    	theHeader.version_major = EndianUtils.swapShort(theHeader.version_major);
			    	theHeader.version_minor = EndianUtils.swapShort(theHeader.version_minor);
			    	theHeader.thiszone = EndianUtils.swapInteger(theHeader.thiszone);
			    	theHeader.sigfigs = EndianUtils.swapInteger(theHeader.sigfigs);
			    	theHeader.snaplen = EndianUtils.swapInteger(theHeader.snaplen);
			    	theHeader.network = EndianUtils.swapInteger(theHeader.network);
		    	}
		    	else {
		    	}
	    	}
    	}
    	return theHeader;
    }
    
    public boolean isValid() {
    	return ((magic_number == 0xa1b2c3d4) || (magic_number == 0xd4c3b2a1));
    }
}
