package xena;

import java.io.Serializable;
import java.nio.ByteBuffer;
import java.util.Arrays;

import org.apache.commons.io.EndianUtils;

public class pcapPacketHeader implements Serializable {
	int ts_sec = 0x01020304;         /* timestamp seconds */
	int ts_usec = 0x05060708;        /* timestamp microseconds */
	int incl_len = 0x090a0b0c;       /* number of octets of packet saved in file */
	int orig_len = 0x0d0e0f10;

    static int size = 16;
    
    public static int getSize() {
    	return size;
    }
	
    public byte[] toByteArray() {
    	ByteBuffer buf = ByteBuffer.allocate(size);
    	buf.putInt(0, ts_sec);
    	buf.putInt(4, ts_usec);
    	buf.putInt(8, incl_len);
    	buf.putInt(12, orig_len);
    	
    	return buf.array();
    }
    
    public static pcapPacketHeader setFromByteArray(byte[] byteArray, int magicNumber) {
    	pcapPacketHeader theHeader = new pcapPacketHeader();

    	if (byteArray != null) {
	    	if (byteArray.length == size) {
		    	theHeader.ts_sec = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 0, 4)), 16);
		    	theHeader.ts_usec = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 4, 8)), 16);
		    	theHeader.incl_len = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 8, 12)), 16);
		    	theHeader.orig_len = (int)Long.parseLong(javax.xml.bind.DatatypeConverter.printHexBinary(Arrays.copyOfRange(byteArray, 12, 16)), 16);
		    	if (magicNumber == 0xD4C3B2A1) {
			    	theHeader.ts_sec = EndianUtils.swapInteger(theHeader.ts_sec);
			    	theHeader.ts_usec = EndianUtils.swapInteger(theHeader.ts_usec);
			    	theHeader.incl_len = EndianUtils.swapInteger(theHeader.incl_len);
			    	theHeader.orig_len = EndianUtils.swapInteger(theHeader.orig_len);
		    	}
	    	}
    	}
    	return theHeader;
    }
}
